// Include the header file of M3C3
#include "M3C3.h"

int main(int argc, char* argv[])
{
  // Local variable declarations
  kcg_float64 value;

  // Declare 2 variables of the M3C3
  // input/output context type
  inC_M3C3 inM3C3Context;
  outC_M3C3 outM3C3Context;

  // Call the generated init function 
  // with the address of the system
  // context as a parameter 
  M3C3_init(&outM3C3Context);

  // Make a Loop
  do 
  {	
    // Read the inputs
    printf("Enter a real value: ");
    scanf("%lf",&value);
	
    // Fill the M3C3 input context
    inM3C3Context.U = value ;

    // Call the generated cyclic function
    // with the address of the system
    // contexts as a parameter 
    M3C3(&inM3C3Context, &outM3C3Context);

    // Treat the outputs
    printf("Sliding values on 3 cycles\n");
    printf("    Mean = %lf\n",outM3C3Context.MeanOn3Cycles);
    printf("    Min  = %lf\n",outM3C3Context.MinOn3Cycles);
    printf("    Max  = %lf\n",outM3C3Context.MaxOn3Cycles);
  } while (1);
  return 0;
}
