-- smuw_mapping.adb

-- ada
with Ada.Unchecked_Conversion;
with Interfaces, Interfaces.C, Interfaces.C.Strings;
with System, System.Storage_Elements; use System.Storage_Elements;
-- kcg
with Kcg_Config, Kcg_Top, linear;
-- wrapper
with Smu_Mapping, Smu_Types; use Smu_Mapping, Smu_Types;
with Smuw_Type, Smuw_Interface;
--with Smuw_Type.Kcg_Config, Smuw_Type.Kcg_Top, Smuw_Type.linear;

package body Smuw_Mapping is

    ---------------------------------------------------------------------------
    -- helpers

    function to_size is new Ada.Unchecked_Conversion(Source => System.Address, Target => Interfaces.C.size_t);
    function to_size is new Ada.Unchecked_Conversion(Source => Storage_Offset, Target => Interfaces.C.size_t);

    ---------------------------------------------------------------------------
    -- forwards

    -- clock


    -- iterators 


    -- tables

    -- linear::MeanCycle3/ linear.Context_MeanCycle3_float64
    scope_3_entries: Mapping_Entry_Array(0..0);
    scope_3: aliased Mapping_Scope;

    -- MinMaxCycle3/ Kcg_Top.Context_MinMaxCycle3
    scope_2_entries: Mapping_Entry_Array(0..1);
    scope_2: aliased Mapping_Scope;

    -- M3C3/ M3C3
    scope_1_entries: Mapping_Entry_Array(0..5);
    scope_1: aliased Mapping_Scope;

    -- 
    scope_0_entries: Mapping_Entry_Array(0..0);
    scope_0: aliased Mapping_Scope;

    ---------------------------------------------------------------------------
    -- definitions

    scope: access Mapping_Scope := null;

    function scope_init return access Mapping_Scope is
        use Smuw_Interface;
    begin
        if scope = null then

            -- linear::MeanCycle3/ linear.Context_MeanCycle3_float64
            scope_3_entries := (0 =>
                (MAP_OUTPUT, Interfaces.C.Strings.new_string("MeanOn3Step"), null, to_bytes(Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.object'size), Smuw_Type.Smuw_linear.Context_MeanCycle3_float64.fields(0).m_nOffset, Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.Type_Utils'access, null, null, null, 1, 0)
            );
            scope_3 := (Interfaces.C.Strings.new_string("linear::MeanCycle3/ linear.Context_MeanCycle3_float64"), scope_3_entries(scope_3_entries'first)'access, 1);

            -- MinMaxCycle3/ Kcg_Top.Context_MinMaxCycle3
            scope_2_entries := (
                (MAP_OUTPUT, Interfaces.C.Strings.new_string("MinOn3Cycles"), null, to_bytes(Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.object'size), Smuw_Type.Smuw_Kcg_Top.Context_MinMaxCycle3.fields(0).m_nOffset, Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.Type_Utils'access, null, null, null, 1, 0),
                (MAP_OUTPUT, Interfaces.C.Strings.new_string("MaxOn3Cycles"), null, to_bytes(Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.object'size), Smuw_Type.Smuw_Kcg_Top.Context_MinMaxCycle3.fields(1).m_nOffset, Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.Type_Utils'access, null, null, null, 1, 1)
            );
            scope_2 := (Interfaces.C.Strings.new_string("MinMaxCycle3/ Kcg_Top.Context_MinMaxCycle3"), scope_2_entries(scope_2_entries'first)'access, 2);

            -- M3C3/ M3C3
            scope_1_entries := (
                (MAP_OUTPUT, Interfaces.C.Strings.new_string("MinOn3Cycles"), null, to_bytes(Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.object'size), to_size(Smuw_Interface.Ctx.MinOn3Cycles'address), Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.Type_Utils'access, null, null, null, 1, 0),
                (MAP_OUTPUT, Interfaces.C.Strings.new_string("MeanOn3Cycles"), null, to_bytes(Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.object'size), to_size(Smuw_Interface.Ctx.MeanOn3Cycles'address), Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.Type_Utils'access, null, null, null, 1, 1),
                (MAP_OUTPUT, Interfaces.C.Strings.new_string("MaxOn3Cycles"), null, to_bytes(Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.object'size), to_size(Smuw_Interface.Ctx.MaxOn3Cycles'address), Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.Type_Utils'access, null, null, null, 1, 2),
                (MAP_INPUT, Interfaces.C.Strings.new_string("U"), null, to_bytes(Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.object'size), to_size(Smuw_Interface.U'address), Smuw_Type.Smuw_Kcg_Config.Kcg_Float64.Type_Utils'access, null, null, null, 1, 3),
                (MAP_INSTANCE, Interfaces.C.Strings.new_string("MinMaxCycle3 1"), null, to_bytes(Smuw_Type.Smuw_Kcg_Top.Context_MinMaxCycle3.object'size), to_size(Smuw_Interface.Ctx.SubCtx_MinMaxCycle3_1'address), null, null, null, scope_2'access, 1, 4),
                (MAP_INSTANCE, Interfaces.C.Strings.new_string("linear::MeanCycle3 1"), null, to_bytes(Smuw_Type.Smuw_linear.Context_MeanCycle3_float64.object'size), to_size(Smuw_Interface.Ctx.SubCtx_MeanCycle3_1'address), null, null, null, scope_3'access, 1, 5)
            );
            scope_1 := (Interfaces.C.Strings.new_string("M3C3/ M3C3"), scope_1_entries(scope_1_entries'first)'access, 6);

            -- 
            scope_0_entries := (0 =>
                (MAP_ROOT, Interfaces.C.Strings.new_string("M3C3"), null, 0, 0, null, null, null, scope_1'access, 1, 0)
            );
            scope_0 := (Interfaces.C.Strings.new_string(""), scope_0_entries(scope_0_entries'first)'access, 1);

            scope := scope_0'access;
        end if;
        return scope;
    end scope_init;

    -- clock


    ---------------------------------------------------------------------------
    -- exports

    function Ssm_GetMapping return access Mapping_Scope is
    begin
        return scope_init;
    end Ssm_GetMapping;

end Smuw_Mapping;
