with Kcg_Config;
with Kcg_Top;
with linear;
with System;
with Ada.Text_IO;
with Ada.Strings.Unbounded;
with Smu_Types, Smu_vTable;
with Interfaces, Interfaces.C, Interfaces.C.Strings;

package Smuw_Snapshot
is
    type PFN_SAVE_CONTEXT is access procedure (adaPath: in String; pValue: in System.Address; pBaseAddr: in System.Address; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
    --******************************************************
    -- Main Snapshot Save/Load functions
    --******************************************************
    procedure save_snapshot(filePath: in String; nCycle: in Integer;
        U: in Kcg_Config.Kcg_Float64;
        Ctx: in Kcg_Top.Context_M3C3;
        bOK: out Boolean);
    procedure load_snapshot(filePath: in String; nCycle: out Integer;
        U: out Kcg_Config.Kcg_Float64;
        Ctx: out Kcg_Top.Context_M3C3;
        bOK: out Boolean);
    --******************************************************
    -- Operators context Save/Load sub-functions and Helpers
    --******************************************************
    procedure save_var(adaPath: in String; pValue: in System.Address; pBaseAddr: in System.Address; pfnTypeToString: Smu_Types.PFN_TYPE_TO_STRING; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
    procedure save_field(adaPath: in String; proj: in String; pValue: in System.Address; pBaseAddr: in System.Address; pfnTypeToString: Smu_Types.PFN_TYPE_TO_STRING; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
    procedure save_context(adaPath: in String; proj: in String; pValue: in System.Address; pBaseAddr: in System.Address; pfnSaveContext: PFN_SAVE_CONTEXT; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
    procedure read_line(snsFile: in Ada.Text_IO.File_Type; strLine : out Ada.Strings.Unbounded.Unbounded_String; bOK: in out Boolean);
    procedure load_var(pValue: in System.Address; pfnStringToType: Smu_Types.PFN_STRING_TO_TYPE; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
    package Smuw_Kcg_Top is
        package Context_M3C3 is
            procedure save(adaPath: in String; pValue: in System.Address; pBaseAddr: in System.Address; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
            procedure load(value: out Kcg_Top.Context_M3C3; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
        end Context_M3C3;
        package Context_MinMaxCycle3 is
            procedure save(adaPath: in String; pValue: in System.Address; pBaseAddr: in System.Address; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
            procedure load(value: out Kcg_Top.Context_MinMaxCycle3; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
        end Context_MinMaxCycle3;
    end Smuw_Kcg_Top;
    package Smuw_linear is
        package Context_MeanCycle3_float64 is
            procedure save(adaPath: in String; pValue: in System.Address; pBaseAddr: in System.Address; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
            procedure load(value: out linear.Context_MeanCycle3_float64; snsFile: in Ada.Text_IO.File_Type; bOK: in out Boolean);
        end Context_MeanCycle3_float64;
    end Smuw_linear;

end Smuw_Snapshot;
