with System;
with Interfaces, Interfaces.C, Interfaces.C.Strings;
with Smu_Types, Smu_vTable;
with Smu_Predef_Conv;

with Kcg_Config;
with Kcg_Top;
with linear;

use type Kcg_Config.Kcg_Char;
use type Kcg_Config.Kcg_Int8;
use type Kcg_Config.Kcg_Int16;
use type Kcg_Config.Kcg_Int32;
use type Kcg_Config.Kcg_Int64;
use type Kcg_Config.Kcg_UInt8;
use type Kcg_Config.Kcg_UInt16;
use type Kcg_Config.Kcg_UInt32;
use type Kcg_Config.Kcg_UInt64;
use type Kcg_Config.Kcg_Float32;
use type Kcg_Config.Kcg_Float64;

package Smuw_Type
is
    package Smuw_Boolean is
        --****************************************************************
        --    Boolean
        --****************************************************************
        vtable: access Smu_vTable.Sim_Type_vTable;
        object: Boolean;
        function to_string(pValue: System.Address; pfnStrAppend: Smu_Types.PFN_STR_APPEND; pStrObj: System.address) return Interfaces.C.int; pragma Convention (C, to_string);
        function check_string(str: Interfaces.C.Strings.chars_ptr; endptr: access System.Address) return Interfaces.C.int; pragma Convention (C, check_string);
        function string_to(szStr: Interfaces.C.Strings.chars_ptr; pValue: System.Address; endptr: access System.Address) return Interfaces.C.int; pragma Convention (C, string_to);
        function is_double_conversion_allowed return Interfaces.C.int; pragma Convention (C, is_double_conversion_allowed);
        function to_double(pValue: System.Address; retValue: access Interfaces.C.double) return Interfaces.C.int; pragma Convention (C, to_double);
        function is_long_conversion_allowed return Interfaces.C.int; pragma Convention (C, is_long_conversion_allowed);
        function to_long(pValue: System.Address; retValue: access Interfaces.C.int) return Interfaces.C.int; pragma Convention (C, to_long);
        procedure compare(pResult: access Interfaces.C.unsigned; pValue1: System.address; pValue2: System.address; pTol: access Smu_Types.Sim_Tolerance; pszPath: Interfaces.C.Strings.chars_ptr; pfnStrListAppend: Smu_Types.PFN_STR_LIST_APPEND; pListErrPaths: System.address); pragma Convention (C, compare);
        function get_signature(pfnStrAppend: Smu_Types.PFN_STR_APPEND; pStrObj: System.address) return Interfaces.C.int; pragma Convention (C, get_signature);
        function set_default_value(pValue: System.address) return Interfaces.C.int; pragma Convention (C, set_default_value);
        Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
            (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
            to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
            get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Boolean.object'Size));
    end Smuw_Boolean;
    package Smuw_Kcg_Config is
        package Kcg_Char is
            --****************************************************************
            --    Kcg_Config.Kcg_Char
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Char;
            function to_string(pValue: System.Address; pfnStrAppend: Smu_Types.PFN_STR_APPEND; pStrObj: System.address) return Interfaces.C.int; pragma Convention (C, to_string);
            function check_string(str: Interfaces.C.Strings.chars_ptr; endptr: access System.Address) return Interfaces.C.int; pragma Convention (C, check_string);
            function string_to(szStr: Interfaces.C.Strings.chars_ptr; pValue: System.Address; endptr: access System.Address) return Interfaces.C.int; pragma Convention (C, string_to);
            function is_double_conversion_allowed return Interfaces.C.int; pragma Convention (C, is_double_conversion_allowed);
            function to_double(pValue: System.Address; retValue: access Interfaces.C.double) return Interfaces.C.int; pragma Convention (C, to_double);
            function is_long_conversion_allowed return Interfaces.C.int; pragma Convention (C, is_long_conversion_allowed);
            function to_long(pValue: System.Address; retValue: access Interfaces.C.int) return Interfaces.C.int; pragma Convention (C, to_long);
            procedure compare(pResult: access Interfaces.C.unsigned; pValue1: System.address; pValue2: System.address; pTol: access Smu_Types.Sim_Tolerance; pszPath: Interfaces.C.Strings.chars_ptr; pfnStrListAppend: Smu_Types.PFN_STR_LIST_APPEND; pListErrPaths: System.address); pragma Convention (C, compare);
            function get_signature(pfnStrAppend: Smu_Types.PFN_STR_APPEND; pStrObj: System.address) return Interfaces.C.int; pragma Convention (C, get_signature);
            function set_default_value(pValue: System.address) return Interfaces.C.int; pragma Convention (C, set_default_value);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Char.object'Size));
        end Kcg_Char;
        package Kcg_Float32 is
            --****************************************************************
            --    Kcg_Config.Kcg_Float32
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Float32;
            function to_string is new Smu_Predef_Conv.predef_kcg_float_to_string(Kcg_Config.Kcg_Float32, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_float_string(Kcg_Config.Kcg_Float32, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_float(Kcg_Config.Kcg_Float32, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_float_to_double(Kcg_Config.Kcg_Float32, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_float_to_long(Kcg_Config.Kcg_Float32, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_float(Kcg_Config.Kcg_Float32, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("F32");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_float_default_value(Kcg_Config.Kcg_Float32);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Float32.object'Size));
        end Kcg_Float32;
        package Kcg_Float64 is
            --****************************************************************
            --    Kcg_Config.Kcg_Float64
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Float64;
            function to_string is new Smu_Predef_Conv.predef_kcg_float_to_string(Kcg_Config.Kcg_Float64, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_float_string(Kcg_Config.Kcg_Float64, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_float(Kcg_Config.Kcg_Float64, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_float_to_double(Kcg_Config.Kcg_Float64, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_float_to_long(Kcg_Config.Kcg_Float64, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_float(Kcg_Config.Kcg_Float64, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("F64");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_float_default_value(Kcg_Config.Kcg_Float64);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Float64.object'Size));
        end Kcg_Float64;
        package Kcg_Int16 is
            --****************************************************************
            --    Kcg_Config.Kcg_Int16
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Int16;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Int16, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_int_string(Kcg_Config.Kcg_Int16, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_int(Kcg_Config.Kcg_Int16, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_int_to_double(Kcg_Config.Kcg_Int16, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_int_to_long(Kcg_Config.Kcg_Int16, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Int16, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("I16");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Int16);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Int16.object'Size));
        end Kcg_Int16;
        package Kcg_Int32 is
            --****************************************************************
            --    Kcg_Config.Kcg_Int32
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Int32;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Int32, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_int_string(Kcg_Config.Kcg_Int32, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_int(Kcg_Config.Kcg_Int32, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_int_to_double(Kcg_Config.Kcg_Int32, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_int_to_long(Kcg_Config.Kcg_Int32, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Int32, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("I32");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Int32);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Int32.object'Size));
        end Kcg_Int32;
        package Kcg_Int64 is
            --****************************************************************
            --    Kcg_Config.Kcg_Int64
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Int64;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Int64, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_int_string(Kcg_Config.Kcg_Int64, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_int(Kcg_Config.Kcg_Int64, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_int_to_double(Kcg_Config.Kcg_Int64, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_int_to_long(Kcg_Config.Kcg_Int64, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Int64, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("I64");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Int64);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Int64.object'Size));
        end Kcg_Int64;
        package Kcg_Int8 is
            --****************************************************************
            --    Kcg_Config.Kcg_Int8
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Int8;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Int8, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_int_string(Kcg_Config.Kcg_Int8, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_int(Kcg_Config.Kcg_Int8, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_int_to_double(Kcg_Config.Kcg_Int8, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_int_to_long(Kcg_Config.Kcg_Int8, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Int8, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("I8");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Int8);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Int8.object'Size));
        end Kcg_Int8;
        package Kcg_Size is
            --****************************************************************
            --    Kcg_Config.Kcg_Size
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Size;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Size, vtable);
            function check_string(str: Interfaces.C.Strings.chars_ptr; endptr: access System.Address) return Interfaces.C.int; pragma Convention (C, check_string);
            function string_to(szStr: Interfaces.C.Strings.chars_ptr; pValue: System.Address; endptr: access System.Address) return Interfaces.C.int; pragma Convention (C, string_to);
            function is_double_conversion_allowed return Interfaces.C.int; pragma Convention (C, is_double_conversion_allowed);
            function to_double(pValue: System.Address; retValue: access Interfaces.C.double) return Interfaces.C.int; pragma Convention (C, to_double);
            function is_long_conversion_allowed return Interfaces.C.int; pragma Convention (C, is_long_conversion_allowed);
            function to_long(pValue: System.Address; retValue: access Interfaces.C.int) return Interfaces.C.int; pragma Convention (C, to_long);
            procedure compare(pResult: access Interfaces.C.unsigned; pValue1: System.address; pValue2: System.address; pTol: access Smu_Types.Sim_Tolerance; pszPath: Interfaces.C.Strings.chars_ptr; pfnStrListAppend: Smu_Types.PFN_STR_LIST_APPEND; pListErrPaths: System.address); pragma Convention (C, compare);
            function get_signature(pfnStrAppend: Smu_Types.PFN_STR_APPEND; pStrObj: System.address) return Interfaces.C.int; pragma Convention (C, get_signature);
            function set_default_value(pValue: System.address) return Interfaces.C.int; pragma Convention (C, set_default_value);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Size.object'Size));
        end Kcg_Size;
        package Kcg_Uint16 is
            --****************************************************************
            --    Kcg_Config.Kcg_Uint16
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Uint16;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Uint16, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_uint_string(Kcg_Config.Kcg_Uint16, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_uint(Kcg_Config.Kcg_Uint16, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_uint_to_double(Kcg_Config.Kcg_Uint16, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_uint_to_long(Kcg_Config.Kcg_Uint16, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Uint16, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("UI16");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Uint16);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Uint16.object'Size));
        end Kcg_Uint16;
        package Kcg_Uint32 is
            --****************************************************************
            --    Kcg_Config.Kcg_Uint32
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Uint32;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Uint32, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_uint_string(Kcg_Config.Kcg_Uint32, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_uint(Kcg_Config.Kcg_Uint32, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_uint_to_double(Kcg_Config.Kcg_Uint32, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_uint_to_long(Kcg_Config.Kcg_Uint32, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Uint32, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("UI32");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Uint32);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Uint32.object'Size));
        end Kcg_Uint32;
        package Kcg_Uint64 is
            --****************************************************************
            --    Kcg_Config.Kcg_Uint64
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Uint64;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Uint64, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_uint_string(Kcg_Config.Kcg_Uint64, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_uint(Kcg_Config.Kcg_Uint64, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_uint_to_double(Kcg_Config.Kcg_Uint64, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_uint_to_long(Kcg_Config.Kcg_Uint64, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Uint64, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("UI64");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Uint64);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Uint64.object'Size));
        end Kcg_Uint64;
        package Kcg_Uint8 is
            --****************************************************************
            --    Kcg_Config.Kcg_Uint8
            --****************************************************************
            vtable: access Smu_vTable.Sim_Type_vTable;
            object: Kcg_Config.Kcg_Uint8;
            function to_string is new Smu_Predef_Conv.predef_kcg_int_to_string(Kcg_Config.Kcg_Uint8, vtable);
            function check_string is new Smu_Predef_Conv.predef_check_kcg_uint_string(Kcg_Config.Kcg_Uint8, vtable);
            function string_to is new Smu_Predef_Conv.predef_string_to_kcg_uint(Kcg_Config.Kcg_Uint8, vtable);
            function is_double_conversion_allowed is new Smu_Predef_Conv.predef_is_double_conversion_allowed(vtable);
            function to_double is new Smu_Predef_Conv.predef_kcg_uint_to_double(Kcg_Config.Kcg_Uint8, vtable);
            function is_long_conversion_allowed is new Smu_Predef_Conv.predef_is_long_conversion_allowed(vtable);
            function to_long is new Smu_Predef_Conv.predef_kcg_uint_to_long(Kcg_Config.Kcg_Uint8, vtable);
            procedure compare is new Smu_Predef_Conv.predef_compare_kcg_int(Kcg_Config.Kcg_Uint8, vtable);
            function get_signature is new Smu_Predef_Conv.predef_get_signature("UI8");
            function set_default_value is new Smu_Predef_Conv.predef_set_kcg_int_default_value(Kcg_Config.Kcg_Uint8);
            Type_Utils: aliased Smu_Types.Sim_Type_Utils := 
                (to_string'access, check_string'access, string_to'access, is_double_conversion_allowed'access, 
                to_double'access, is_long_conversion_allowed'access, to_long'access, compare'access,
                get_signature'access, set_default_value'access, Smu_Types.to_bytes(Smuw_Kcg_Config.Kcg_Uint8.object'Size));
        end Kcg_Uint8;
    end Smuw_Kcg_Config;
    package Smuw_Kcg_Top is
        package Context_M3C3 is
            --****************************************************************
            --    Kcg_Top.Context_M3C3
            --****************************************************************
            object: Kcg_Top.Context_M3C3;
            function fields return Smu_Types.Array_Sim_Field_Utils;
            fields_data: Smu_Types.Array_Sim_Field_Utils(0..4);
            fields_access: access Smu_Types.Sim_Field_Utils := fields_data(fields_data'first)'access;
        end Context_M3C3;
        package Context_MinMaxCycle3 is
            --****************************************************************
            --    Kcg_Top.Context_MinMaxCycle3
            --****************************************************************
            object: Kcg_Top.Context_MinMaxCycle3;
            function fields return Smu_Types.Array_Sim_Field_Utils;
            fields_data: Smu_Types.Array_Sim_Field_Utils(0..4);
            fields_access: access Smu_Types.Sim_Field_Utils := fields_data(fields_data'first)'access;
        end Context_MinMaxCycle3;
    end Smuw_Kcg_Top;
    package Smuw_linear is
        package Context_MeanCycle3_float64 is
            --****************************************************************
            --    linear.Context_MeanCycle3_float64
            --****************************************************************
            object: linear.Context_MeanCycle3_float64;
            function fields return Smu_Types.Array_Sim_Field_Utils;
            fields_data: Smu_Types.Array_Sim_Field_Utils(0..3);
            fields_access: access Smu_Types.Sim_Field_Utils := fields_data(fields_data'first)'access;
        end Context_MeanCycle3_float64;
    end Smuw_linear;

end Smuw_Type;
